Index: trunk/zoo-project/zoo-kernel/request_parser.c
===================================================================
--- trunk/zoo-project/zoo-kernel/request_parser.c	(revision 938)
+++ trunk/zoo-project/zoo-kernel/request_parser.c	(revision 939)
@@ -1070,12 +1070,20 @@
 					       buffersize);
 				}
-			      else if (cur5 != NULL)/*
-				     && cur5->type == XML_CDATA_SECTION_NODE)*/{
-				while(cur5!=NULL && cur5->type != XML_CDATA_SECTION_NODE)
-				  cur5=cur5->next;
-				xmlFree(mv);
-				if(cur5!=NULL && cur5->content!=NULL){
-				  mv=xmlStrdup(cur5->content);
-				}
+			      else if (cur5 != NULL){
+				if(ltmp!= NULL && strstr(ltmp->value,"text/")!=NULL){
+				  xmlChar *tmp = xmlNodeListGetRawString (doc,
+									  cur4->xmlChildrenNode,
+									  0);
+				  addToMap (tmpmaps->content, "value",
+					    (char *) tmp);
+				  xmlFree (tmp);
+				}else{
+				  while(cur5!=NULL && cur5->type != XML_CDATA_SECTION_NODE)
+				    cur5=cur5->next;
+				  xmlFree(mv);
+				  if(cur5!=NULL && cur5->content!=NULL){
+				    mv=xmlStrdup(cur5->content);
+				  }
+			 	}
 			      }
 			    }
@@ -1861,5 +1869,5 @@
   if (r_inputs == NULL){
     if(mandatory>0){
-      char *replace=_("Mandatory parameter <%s> was not specified");
+      const char *replace=_("Mandatory parameter <%s> was not specified");
       char *message=(char*)malloc((strlen(replace)+strlen(toCheck)+1)*sizeof(char));
       sprintf(message,replace,toCheck);
@@ -1910,5 +1918,5 @@
     }
     if(hasValidValue<0){
-      char *replace=_("The value <%s> was not recognized, %s %s the only acceptable value.");
+      const char *replace=_("The value <%s> was not recognized, %s %s the only acceptable value.");
       nb=0;
       char *vvalues=NULL;
Index: trunk/zoo-project/zoo-kernel/service_internal_hpc.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal_hpc.c	(revision 938)
+++ trunk/zoo-project/zoo-kernel/service_internal_hpc.c	(revision 939)
@@ -69,5 +69,5 @@
 	  dupElements(cur)
 	};
-	char *geoLink="wcs_link";
+	const char *geoLink="wcs_link";
 	if(geo==2){
 	  geoLink="wfs_link";
@@ -213,5 +213,5 @@
       zooLock* lck;
       if((lck=lockFile(*conf,argv[1]->value,'r'))==NULL){
-	char* templateStr=_("Unable to lock the file for %s in read mode.");
+	const char* templateStr=_("Unable to lock the file for %s in read mode.");
 	char *tmpMessage=(char*)malloc((strlen(templateStr)+strlen(argv[0]->value)+1)*sizeof(char));
 	sprintf(tmpMessage,templateStr,argv[0]->value);
@@ -251,5 +251,5 @@
       if(unlockFile(*conf,zoo_file_locks[i])<1){
 	map* argv=getMapArray(queueMaps->content,"input",i);
-	char* templateStr=_("Unable to unlock the file for %s after execution.");
+	const char* templateStr=_("Unable to unlock the file for %s after execution.");
 	char *tmpMessage=(char*)malloc((strlen(templateStr)+strlen(argv->value)+1)*sizeof(char));
 	sprintf(tmpMessage,templateStr,argv->value);
Index: trunk/zoo-project/zoo-kernel/service_internal_python.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal_python.c	(revision 938)
+++ trunk/zoo-project/zoo-kernel/service_internal_python.c	(revision 939)
@@ -355,5 +355,5 @@
 #endif
     char *pStrErrorMessage = PyString_AsString(pvalue);
-  char *tmp0=_("Python module %s cannot be loaded. Message: %s\n");
+  const char *tmp0=_("Python module %s cannot be loaded. Message: %s\n");
   
   PyObject *trace=PyObject_Str(pvalue);
@@ -393,5 +393,5 @@
       if(pbt!=NULL)
 	free(pbt);
-      char* format=_("%s\nUnable to run your python process properly. Please check the following messages : %s");
+      const char* format=_("%s\nUnable to run your python process properly. Please check the following messages : %s");
       pbt=(char*)malloc((strlen(format)+strlen(tpbt)+strlen(PyString_AsString(trace))+1)*sizeof(char));
       sprintf(pbt,format,tpbt,PyString_AsString(trace));
@@ -400,5 +400,5 @@
       if(pbt!=NULL)
 	free(pbt);
-      char* format=_("%s \n Unable to run your python process properly. Unable to provide any further information.");
+      const char* format=_("%s \n Unable to run your python process properly. Unable to provide any further information.");
       pbt=(char*)malloc((strlen(format)+strlen(tpbt)+strlen(PyString_AsString(trace))+1)*sizeof(char));
       sprintf(pbt,format,tpbt);
Index: trunk/zoo-project/zoo-kernel/sshapi.c
===================================================================
--- trunk/zoo-project/zoo-kernel/sshapi.c	(revision 938)
+++ trunk/zoo-project/zoo-kernel/sshapi.c	(revision 939)
@@ -730,5 +730,5 @@
 	if((lck=lockFile(*conf,argv[1]->value,'w'))!=NULL){/**/
 	  if(ssh_copy(*conf,argv[1]->value,argv[2]->value,ssh_get_cnt(*conf))!=true){
-	    char* templateStr=_("Unable to copy over SSH the file requested for setting the value of %s.");
+	    const char* templateStr=_("Unable to copy over SSH the file requested for setting the value of %s.");
 	    char *tmpMessage=(char*)malloc((strlen(templateStr)+strlen(argv[0]->value)+1)*sizeof(char));
 	    sprintf(tmpMessage,templateStr,argv[0]->value);