Index: trunk/zoo-project/HISTORY.txt
===================================================================
--- trunk/zoo-project/HISTORY.txt	(revision 959)
+++ trunk/zoo-project/HISTORY.txt	(revision 960)
@@ -1,3 +1,4 @@
 Version 1.8.0-dev
+  * Add Dockerfile and docker-compose environment with pgbouncer, see #177
   * Add documentation on how to use asyncrhonous execution using the Javascript
   ZOO-API
Index: trunk/zoo-project/zoo-kernel/locale/po/messages.po
===================================================================
--- trunk/zoo-project/zoo-kernel/locale/po/messages.po	(revision 959)
+++ trunk/zoo-project/zoo-kernel/locale/po/messages.po	(revision 960)
@@ -1,12 +1,13 @@
-# ZOO-Kernel Internationalization.
-# Copyright (C) 2015 GeoLabs SARL
+# SOME DESCRIPTIVE TITLE.
+# Copyright (C) YEAR THE PACKAGE'S COPYRIGHT HOLDER
 # This file is distributed under the same license as the PACKAGE package.
-# Gerald Fenoy <gerald.fenoy@geolabs.fr>, 2015.
+# FIRST AUTHOR <EMAIL@ADDRESS>, YEAR.
 #
-msgid ""
-msgstr ""
-"Project-Id-Version: ZOO-Kernel 1.5.0\n"
-"Report-Msgid-Bugs-To: zoo-discuss@lists.osgeo.org\n"
-"POT-Creation-Date: 2015-07-02 18:06+0200\n"
+#, fuzzy
+msgid ""
+msgstr ""
+"Project-Id-Version: PACKAGE VERSION\n"
+"Report-Msgid-Bugs-To: \n"
+"POT-Creation-Date: 2020-08-14 13:32+0200\n"
 "PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
@@ -14,54 +15,59 @@
 "Language: \n"
 "MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Type: text/plain; charset=CHARSET\n"
 "Content-Transfer-Encoding: 8bit\n"
 
-#: caching.c:217 caching.c:235 caching.c:356 request_parser.c:214
-#: request_parser.c:225 request_parser.c:262 request_parser.c:403
-#: request_parser.c:414 request_parser.c:441 request_parser.c:537
-#: request_parser.c:562 request_parser.c:665 request_parser.c:782
-#: request_parser.c:1112 request_parser.c:1204 zcfg2yaml.c:38
-#: zoo_service_loader.c:259 zoo_service_loader.c:880 zoo_service_loader.c:1363
-#: zoo_service_loader.c:1559
+#: caching.c:507 caching.c:528 caching.c:756 request_parser.c:224
+#: request_parser.c:235 request_parser.c:272 request_parser.c:412
+#: request_parser.c:470 request_parser.c:522 request_parser.c:581
+#: request_parser.c:711 request_parser.c:837 request_parser.c:1334
+#: request_parser.c:1423 service_callback.c:202 zcfg2yaml.c:38
+#: zoo_service_loader.c:352 zoo_service_loader.c:627 zoo_service_loader.c:1660
+#: zoo_service_loader.c:2072 zoo_service_loader.c:2781
 msgid "Unable to allocate memory"
-msgstr "Unable to allocate memory"
-
-#: caching.c:344
+msgstr ""
+
+#: caching.c:534
+#, c-format
+msgid "Unable to download the file for the input <%s>, response code was : %d."
+msgstr ""
+
+#: caching.c:742
 msgid "Unable to download the file."
-msgstr "Unable to download the file."
-
-#: request_parser.c:92
+msgstr ""
+
+#: request_parser.c:100
 #, c-format
 msgid "The maximum allowed occurrences for <%s> (%i) was exceeded."
-msgstr "The maximum allowed occurrences for <%s> (%i) was exceeded."
-
-#: request_parser.c:113
+msgstr ""
+
+#: request_parser.c:121
 #, c-format
 msgid "ZOO-Kernel was unable to load your data for %s position %s."
-msgstr "ZOO-Kernel was unable to load your data for %s position %s."
-
-#: request_parser.c:124
+msgstr ""
+
+#: request_parser.c:132
 #, c-format
 msgid "The maximum allowed occurrences for <%s> is one."
-msgstr "The maximum allowed occurrences for <%s> is one."
-
-#: request_parser.c:315
+msgstr ""
+
+#: request_parser.c:324
 #, c-format
 msgid "Unable to find a valid protocol to download the remote file %s"
-msgstr "Unable to find a valid protocol to download the remote file %s"
-
-#: request_parser.c:613
+msgstr ""
+
+#: request_parser.c:659
 msgid "Unable to add a request in the queue."
-msgstr "Unable to add a request in the queue."
-
-#: request_parser.c:1021
+msgstr ""
+
+#: request_parser.c:1185
 msgid "Unable to append maps to maps."
-msgstr "Unable to append maps to maps."
-
-#: request_parser.c:1291
+msgstr ""
+
+#: request_parser.c:1507
 msgid "Duplicate <Output> elements in WPS Execute request"
-msgstr "Duplicate <Output> elements in WPS Execute request"
-
-#: request_parser.c:1487
+msgstr ""
+
+#: request_parser.c:1712
 #, c-format
 msgid ""
@@ -70,9 +76,6 @@
 "this limit (%f MB)."
 msgstr ""
-"The <%s> parameter has a size limit (%s MB) defined in the ZOO "
-"ServicesProvider configuration file, but the reference you provided exceeds "
-"this limit (%f MB)."
-
-#: request_parser.c:1519
+
+#: request_parser.c:1745
 #, c-format
 msgid ""
@@ -80,8 +83,6 @@
 "to the ZOO ServicesProvider configuration file."
 msgstr ""
-"The <%s> argument was not specified in DataInputs but is required according "
-"to the ZOO ServicesProvider configuration file."
-
-#: request_parser.c:1545
+
+#: request_parser.c:1771
 #, c-format
 msgid ""
@@ -89,31 +90,29 @@
 "in the ZOO Configuration File)."
 msgstr ""
-"The <%s> argument specified as %s identifier was not recognized (not defined "
-"in the ZOO Configuration File)."
-
-#: request_parser.c:1663
+
+#: request_parser.c:1893
 #, c-format
 msgid "Mandatory parameter <%s> was not specified"
-msgstr "Mandatory parameter <%s> was not specified"
-
-#: request_parser.c:1712
+msgstr ""
+
+#: request_parser.c:1942
 #, c-format
 msgid "The value <%s> was not recognized, %s %s the only acceptable value."
-msgstr "The value <%s> was not recognized, %s %s the only acceptable value."
-
-#: request_parser.c:1715
+msgstr ""
+
+#: request_parser.c:1945
 msgid "is"
-msgstr "is"
-
-#: request_parser.c:1727
+msgstr ""
+
+#: request_parser.c:1957
 msgid "are"
-msgstr "are"
-
-#: response_print.c:1630
+msgstr ""
+
+#: response_print.c:1933
 #, c-format
 msgid "The service \"%s\" ran successfully."
-msgstr "The service \"%s\" ran successfully."
-
-#: response_print.c:1638
+msgstr ""
+
+#: response_print.c:1941
 #, c-format
 msgid ""
@@ -121,9 +120,7 @@
 "get the up-to-date status of the service."
 msgstr ""
-"The ZOO service \"%s\" is currently running. Please reload this document to "
-"get the up-to-date status of the service."
-
-#: response_print.c:1644
-#, fuzzy, c-format
+
+#: response_print.c:1947
+#, c-format
 msgid ""
 "The service \"%s\" was accepted by the ZOO-Kernel and is running as a "
@@ -131,44 +128,39 @@
 "provided in this document to get the up-to-date status and results."
 msgstr ""
-"The service \"%s\" was accepted by the ZOO kernel and is running as a "
-"background task. Please access the URL in the statusLocation attribute "
-"provided in this document to get the up-to-date status and results."
-
-#: response_print.c:1661
+
+#: response_print.c:1964
 msgid "No more information available"
-msgstr "No more information available"
-
-#: response_print.c:1668
+msgstr ""
+
+#: response_print.c:1971
 #, c-format
 msgid "error code not know : %i\n"
-msgstr "error code not know : %i\n"
-
-#: response_print.c:1760
+msgstr ""
+
+#: response_print.c:2061
 msgid "Lock failed."
-msgstr "Lock failed."
-
-#: response_print.c:1773
+msgstr ""
+
+#: response_print.c:2074
 #, c-format
 msgid "Unable to create the file \"%s\" for storing the ExecuteResponse."
-msgstr "Unable to create the file \"%s\" for storing the ExecuteResponse."
-
-#: response_print.c:2290
+msgstr ""
+
+#: response_print.c:2613
 msgid "No debug message available"
-msgstr "No debug message available"
-
-#: response_print.c:2378
+msgstr ""
+
+#: response_print.c:2711
 #, c-format
 msgid "Unable to create the file \"%s\" for storing the session maps."
-msgstr "Unable to create the file \"%s\" for storing the session maps."
-
-#: response_print.c:2394
+msgstr ""
+
+#: response_print.c:2725
 msgid ""
 "Unable to run the Service. The message returned back by the Service was the "
 "following: "
 msgstr ""
-"Unable to run the Service. The message returned back by the Service was the "
-"following: "
-
-#: response_print.c:2395
+
+#: response_print.c:2726
 #, c-format
 msgid ""
@@ -176,21 +168,22 @@
 "following: %s"
 msgstr ""
-"Unable to run the Service. The message returned back by the Service was the "
-"following: %s"
-
-#: response_print.c:2398 response_print.c:2399
+
+#: response_print.c:2729 response_print.c:2730
 msgid ""
 "Unable to run the Service. No more information was returned back by the "
 "Service."
 msgstr ""
-"Unable to run the Service. No more information was returned back by the "
-"Service."
-
-#: response_print.c:2486
+
+#: response_print.c:2836 service_json.c:1056
 #, c-format
 msgid "Unable to create the file \"%s\" for storing the %s final result."
-msgstr "Unable to create the file \"%s\" for storing the %s final result."
-
-#: response_print.c:2572
+msgstr ""
+
+#: response_print.c:2846 service_json.c:1070
+#, c-format
+msgid "No value found for the requested output %s."
+msgstr ""
+
+#: response_print.c:2957
 #, c-format
 msgid ""
@@ -198,58 +191,215 @@
 "parameter name: \"%s\"."
 msgstr ""
-"Wrong RawDataOutput parameter: unable to fetch any result for the given "
-"parameter name: \"%s\"."
-
-#: server_internal.c:869 server_internal.c:946
+
+#: server_internal.c:996 server_internal.c:1076
 msgid ""
 "The JobID from the request does not match any of the Jobs running on this "
 "server"
 msgstr ""
-"The JobID from the request does not match any of the Jobs running on this "
-"server"
-
-#: server_internal.c:875 server_internal.c:907
-msgid "The result for the requested JobID has not yet been generated. "
-msgstr "The result for the requested JobID has not yet been generated. "
-
-#: server_internal.c:988
+
+#: server_internal.c:1002
+msgid ""
+"The result for the requested JobID has not yet been generated. The service "
+"is currently running."
+msgstr ""
+
+#: server_internal.c:1036
+msgid ""
+"The result for the requested JobID has not yet been generated. The service "
+"ends but it still needs to produce the outputs."
+msgstr ""
+
+#: server_internal.c:1118
 msgid "The job cannot be removed, a file cannot be removed"
-msgstr "The job cannot be removed, a file cannot be removed"
-
-#: server_internal.c:1063
+msgstr ""
+
+#: server_internal.c:1198
 msgid "Unable to open the registry directory."
 msgstr ""
 
-#: server_internal.c:1082
+#: server_internal.c:1217
 msgid "Unable to allocate memory."
-msgstr "Unable to allocate memory."
-
-#: server_internal.c:1093 zoo_service_loader.c:276 zoo_service_loader.c:1384
-#: zoo_service_loader.c:1427
+msgstr ""
+
+#: server_internal.c:1228 zoo_service_loader.c:367 zoo_service_loader.c:413
 #, c-format
 msgid "Unable to parse the ZCFG file: %s (%s)"
-msgstr "Unable to parse the ZCFG file: %s (%s)"
-
-#: server_internal.c:1096 zoo_service_loader.c:279 zoo_service_loader.c:1389
-#: zoo_service_loader.c:1431
+msgstr ""
+
+#: server_internal.c:1231 zoo_service_loader.c:370 zoo_service_loader.c:417
 #, c-format
 msgid "Unable to parse the ZCFG file: %s."
-msgstr "Unable to parse the ZCFG file: %s."
-
-#: service_internal_ms.c:136
+msgstr ""
+
+#: service_callback.c:857
+msgid "Unable to create a new thread"
+msgstr ""
+
+#: service_internal_hpc.c:92 service_internal_hpc.c:167
+msgid "Download link"
+msgstr ""
+
+#: service_internal_hpc.c:93 service_internal_hpc.c:168
+msgid "The download link"
+msgstr ""
+
+#: service_internal_hpc.c:103
+msgid "WMS link"
+msgstr ""
+
+#: service_internal_hpc.c:104
+msgid "The WMS link"
+msgstr ""
+
+#: service_internal_hpc.c:118
+msgid "WFS link"
+msgstr ""
+
+#: service_internal_hpc.c:119
+msgid "The WFS link"
+msgstr ""
+
+#: service_internal_hpc.c:122
+msgid "WCS link"
+msgstr ""
+
+#: service_internal_hpc.c:123
+msgid "The WCS link"
+msgstr ""
+
+#: service_internal_hpc.c:215
+#, c-format
+msgid "Unable to lock the file for %s in read mode."
+msgstr ""
+
+#: service_internal_hpc.c:253
+#, c-format
+msgid "Unable to unlock the file for %s after execution."
+msgstr ""
+
+#: service_internal_hpc.c:356
+msgid "The synchronous mode is not supported by this type of service"
+msgstr ""
+
+#: service_internal_hpc.c:489 sshapi.c:742
+msgid "Unable to lock the file for upload!"
+msgstr ""
+
+#: service_internal_hpc.c:738 service_internal_hpc.c:740
+msgid "There is no remote_work_path defined in your section!"
+msgstr ""
+
+#: service_internal_hpc.c:764 service_internal_hpc.c:768
+msgid "Unable to upload the script"
+msgstr ""
+
+#: service_internal_hpc.c:801 zoo_service_loader.c:851
+msgid "No message provided"
+msgstr ""
+
+#: service_internal_hpc.c:803
+msgid "Unable to fetch the remote error log file"
+msgstr ""
+
+#: service_internal_hpc.c:852 service_internal_hpc.c:853
+msgid "Unable to bind socket!"
+msgstr ""
+
+#: service_internal_hpc.c:874 service_internal_hpc.c:875
+msgid "Listen error"
+msgstr ""
+
+#: service_internal_hpc.c:892 service_internal_hpc.c:893
+msgid "Accept error"
+msgstr ""
+
+#: service_internal_hpc.c:918 service_internal_hpc.c:919
+msgid "Read closed"
+msgstr ""
+
+#: service_internal_hpc.c:936 service_internal_hpc.c:937
+msgid "Read error"
+msgstr ""
+
+#: service_internal_hpc.c:1030 service_internal_hpc.c:1031
+#: service_internal_hpc.c:1036 service_internal_hpc.c:1037
+#: service_internal_hpc.c:1111 service_internal_hpc.c:1112
+#: service_internal_hpc.c:1117 service_internal_hpc.c:1118
+#, c-format
+msgid "Unable to fetch the remote file for %s"
+msgstr ""
+
+#: service_internal_hpc.c:1135 service_internal_hpc.c:1136
+msgid "HPC Execution failed!"
+msgstr ""
+
+#: service_internal_hpc.c:1153 service_internal_hpc.c:1154
+msgid "Unable to parse the value returned by remote execution"
+msgstr ""
+
+#: service_internal_mono.c:115
+msgid "The ZMaps.dll assembly cannot be found!"
+msgstr ""
+
+#: service_internal_mono.c:195
+#, c-format
+msgid "Your service assembly: %s cannot be found!"
+msgstr ""
+
+#: service_internal_mono.c:196
+#, c-format
+msgid "Your service assembly %s cannot be found!"
+msgstr ""
+
+#: service_internal_mono.c:209 service_internal_mono.c:210
+#, c-format
+msgid "Your service class method %s::%s cannot be found!"
+msgstr ""
+
+#: service_internal_mono.c:218 service_internal_mono.c:219
+#, c-format
+msgid "Your service static method %s cannot be found!"
+msgstr ""
+
+#: service_internal_ms.c:156
 msgid "Unable to find any mapserverAddress defined in the main.cfg file"
-msgstr "Unable to find any mapserverAddress defined in the main.cfg file"
-
-#: service_internal_php.c:227
+msgstr ""
+
+#: service_internal_ms.c:199
+msgid ""
+"The ZOO-Kernel was able to retrieve the data but could not read it as "
+"geographic data."
+msgstr ""
+
+#: service_internal_ms.c:201
+msgid ""
+"The ZOO-Kernel was able to retrieve the data but could not access any "
+"feature or pixel in te resulting file."
+msgstr ""
+
+#: service_internal_ms.c:203
+msgid "Unable to find any geographic data"
+msgstr ""
+
+#: service_internal_ms.c:261
+#, c-format
+msgid "Unable to create the mapfile for %s because of missing values."
+msgstr ""
+
+#: service_internal_ms.c:1338
+msgid "Unable to open your template mapfile!"
+msgstr ""
+
+#: service_internal_php.c:225 service_internal_php7.c:236
 #, c-format
 msgid "Unable to load the PHP file %s"
-msgstr "Unable to load the PHP file %s"
-
-#: service_internal_python.c:316
+msgstr ""
+
+#: service_internal_python.c:358
 #, c-format
 msgid "Python module %s cannot be loaded. Message: %s\n"
-msgstr "Python module %s cannot be loaded. Message: %s\n"
-
-#: service_internal_python.c:355
+msgstr ""
+
+#: service_internal_python.c:396
 #, c-format
 msgid ""
@@ -258,9 +408,6 @@
 "messages : %s"
 msgstr ""
-"%s\n"
-"Unable to run your python process properly. Please check the following "
-"messages : %s"
-
-#: service_internal_python.c:361
+
+#: service_internal_python.c:403
 #, c-format
 msgid ""
@@ -269,24 +416,84 @@
 "information."
 msgstr ""
-"%s \n"
-" Unable to run your python process properly. Unable to provide any further "
-"information."
-
-#: zoo_service_loader.c:352
-#, c-format
-msgid "ZOO Kernel failed to process your request, receiving signal %d = %s"
-msgstr "ZOO Kernel failed to process your request, receiving signal %d = %s"
-
-#: zoo_service_loader.c:527
+
+#: service_internal_r.c:134
+msgid "Unable to load your R file"
+msgstr ""
+
+#: service_internal_r.c:179 service_internal_r.c:180
+msgid "Unable to run your R service: "
+msgstr ""
+
+#: service_json.c:802 service_json.c:835
+#, c-format
+msgid "Missing input for %s"
+msgstr ""
+
+#: service_json.c:822
+#, c-format
+msgid "Issue with input %s"
+msgstr ""
+
+#: service_json.c:1158
+msgid "Status location"
+msgstr ""
+
+#: service_json.c:1172
+msgid "Result location"
+msgstr ""
+
+#: service_json.c:1239
+msgid "ZOO-Kernel accepted to run your service!"
+msgstr ""
+
+#: service_json.c:1245
+msgid "ZOO-Kernel is currently running your service!"
+msgstr ""
+
+#: service_json.c:1251
+msgid "ZOO-Kernel pause your service!"
+msgstr ""
+
+#: service_json.c:1257
+msgid "ZOO-Kernel successfully run your service!"
+msgstr ""
+
+#: service_json.c:1264
+msgid "ZOO-Kernel failed to run your service!"
+msgstr ""
+
+#: service_json.c:1285
+msgid "Unable to store the statusInfo!"
+msgstr ""
+
+#: sqlapi.c:171
+msgid "Failed to connect to the database backend"
+msgstr ""
+
+#: sshapi.c:112
+msgid "Issue when invoking gethostbyname!"
+msgstr ""
+
+#: sshapi.c:732
+#, c-format
+msgid "Unable to copy over SSH the file requested for setting the value of %s."
+msgstr ""
+
+#: zoo_service_loader.c:1043 zoo_service_loader.c:1088
+#, c-format
+msgid "ZOO Kernel failed to process your request, receiving signal %d = %s "
+msgstr ""
+
+#: zoo_service_loader.c:1274
 #, c-format
 msgid "Error occurred while running the %s function: %s"
-msgstr "Error occurred while running the %s function: %s"
-
-#: zoo_service_loader.c:578
+msgstr ""
+
+#: zoo_service_loader.c:1325
 #, c-format
 msgid "Unable to load C Library %s"
-msgstr "Unable to load C Library %s"
-
-#: zoo_service_loader.c:672
+msgstr ""
+
+#: zoo_service_loader.c:1451
 #, c-format
 msgid ""
@@ -294,46 +501,36 @@
 "Kernel.\n"
 msgstr ""
-"Programming Language (%s) set in ZCFG file is not currently supported by ZOO "
-"Kernel.\n"
-
-#: zoo_service_loader.c:737
+
+#: zoo_service_loader.c:1516
 msgid "Unable to cache HTTP POST Execute request."
-msgstr "Unable to cache HTTP POST Execute request."
-
-#: zoo_service_loader.c:895
+msgstr ""
+
+#: zoo_service_loader.c:1680
 msgid "Unable to load the main.cfg file."
-msgstr "Unable to load the main.cfg file."
-
-#: zoo_service_loader.c:895
-msgid "%s The following file: %s cannot be found."
-msgstr "%s The following file: %s cannot be found."
-
-#: zoo_service_loader.c:940
+msgstr ""
+
+#: zoo_service_loader.c:1728
 #, c-format
 msgid "The value %s is not supported for the <language> parameter"
-msgstr "The value %s is not supported for the <language> parameter"
-
-#: zoo_service_loader.c:1238
-#, fuzzy
-msgid "The specified path does not exist."
-msgstr "The specified path path does not exist."
-
-#: zoo_service_loader.c:1303
-#, c-format
-msgid ""
-"Unable to parse the ZCFG file for the following ZOO-Service: %s. Message: %s"
-msgstr ""
-"Unable to parse the ZCFG file for the following ZOO-Service: %s. Message: %s"
-
-#: zoo_service_loader.c:1308
-#, c-format
-msgid "Unable to parse the ZCFG file for the following ZOO-Service: %s."
-msgstr "Unable to parse the ZCFG file for the following ZOO-Service: %s."
-
-#: zoo_service_loader.c:1534
-msgid "Unable to run Execute request using the GET HTTP method"
-msgstr "Unable to run Execute request using the GET HTTP method"
-
-#: zoo_service_loader.c:1606
+msgstr ""
+
+#: zoo_service_loader.c:1825
+#, c-format
+msgid "CORS is enabled.\r\n"
+msgstr ""
+
+#: zoo_service_loader.c:1879
+msgid "OGC API - Processing is not supported by this ZOO-Kernel."
+msgstr ""
+
+#: zoo_service_loader.c:1899
+msgid "Unable to load the oas.cfg file."
+msgstr ""
+
+#: zoo_service_loader.c:1968
+msgid "The ressource is not available"
+msgstr ""
+
+#: zoo_service_loader.c:2100 zoo_service_loader.c:2805
 #, c-format
 msgid ""
@@ -341,28 +538,32 @@
 "processes in the list returned by a GetCapabilities request."
 msgstr ""
-"The value for <identifier> seems to be wrong (%s). Please specify one of the "
-"processes in the list returned by a GetCapabilities request."
-
-#: zoo_service_loader.c:1733
+
+#: zoo_service_loader.c:2191 zoo_service_loader.c:3000
+msgid "Initializing"
+msgstr ""
+
+#: zoo_service_loader.c:2593
+msgid "The specified path does not exist."
+msgstr ""
+
+#: zoo_service_loader.c:2706
+msgid "Unable to run Execute request using the GET HTTP method"
+msgstr ""
+
+#: zoo_service_loader.c:2881
 msgid ""
 "The status parameter cannot be set to true if storeExecuteResponse is set to "
 "false. Please modify your request parameters."
 msgstr ""
-"The status parameter cannot be set to true if storeExecuteResponse is set to "
-"false. Please modify your request parameters."
-
-#: zoo_service_loader.c:1761
+
+#: zoo_service_loader.c:2909
 msgid "The process does not permit the desired execution mode."
-msgstr "The process does not permit the desired execution mode."
-
-#: zoo_service_loader.c:1837
-msgid "No message provided"
-msgstr "No message provided"
-
-#: zoo_service_loader.c:1995
-msgid "Initializing"
-msgstr "Initializing"
-
-#: zoo_service_loader.c:2142
+msgstr ""
+
+#: zoo_service_loader.c:3183
+msgid "Issue with geographic data"
+msgstr ""
+
+#: zoo_service_loader.c:3204
 msgid "Unable to run the child process properly"
-msgstr "Unable to run the child process properly"
+msgstr ""
Index: trunk/zoo-project/zoo-services/ogr/ogr2ogr/cgi-env/Ogr2Ogr.zcfg
===================================================================
--- trunk/zoo-project/zoo-services/ogr/ogr2ogr/cgi-env/Ogr2Ogr.zcfg	(revision 959)
+++ trunk/zoo-project/zoo-services/ogr/ogr2ogr/cgi-env/Ogr2Ogr.zcfg	(revision 960)
@@ -48,4 +48,22 @@
     </Supported>
    </LiteralData>
+  [LCO]
+   Title = Format of the output data
+   Abstract = Select the output format.
+   minOccurs = 0
+   maxOccurs = 1024
+   <LiteralData>
+    DataType = string
+    <Default />
+   </LiteralData>
+  [DSCO]
+   Title = Format of the output data
+   Abstract = Select the output format.
+   minOccurs = 0
+   maxOccurs = 1024
+   <LiteralData>
+    DataType = string
+    <Default />
+   </LiteralData>
  </DataInputs>
  <DataOutputs>
Index: trunk/zoo-project/zoo-services/ogr/ogr2ogr/service.c
===================================================================
--- trunk/zoo-project/zoo-services/ogr/ogr2ogr/service.c	(revision 959)
+++ trunk/zoo-project/zoo-services/ogr/ogr2ogr/service.c	(revision 960)
@@ -171,13 +171,31 @@
 
     tmpMap=NULL;
-    tmpMap=getMapFromMaps(inputs,"DSCO","value");
-    if(tmpMap!=NULL && strncasecmp(tmpMap->value,"NULL",4)!=0){
-	  papszDSCO = CSLAddString(papszDSCO, tmpMap->value );
-    }
-
-    tmpMap=NULL;
-    tmpMap=getMapFromMaps(inputs,"LCO","value");
+    int length=1;
+    tmpMap=getMapFromMaps(inputs,"DSCO","length");
+    if(tmpMap!=NULL){
+	    length=atoi(tmpMap->value);
+    }
+    maps* tmpMaps=getMaps(inputs,"DSCO");
+    for(int i=0;i<length;i++){
+	tmpMap=getMapArray(tmpMaps->content,"value",i);
+    	//tmpMap=getMapFromMaps(inputs,"DSCO","value");
+    	if(tmpMap!=NULL && strncasecmp(tmpMap->value,"NULL",4)!=0){
+	      papszDSCO = CSLAddString(papszDSCO, tmpMap->value );
+    	}
+    }
+
+    tmpMap=NULL;
+    length=1;
+    tmpMap=getMapFromMaps(inputs,"LCO","length");
+    if(tmpMap!=NULL){
+	    length=atoi(tmpMap->value);
+    }
+    tmpMaps=getMaps(inputs,"LCO");
+    for(int i=0;i<length;i++){
+	tmpMap=getMapArray(tmpMaps->content,"value",i);
+    //tmpMap=getMapFromMaps(inputs,"LCO","value");
     if(tmpMap!=NULL && strncasecmp(tmpMap->value,"NULL",4)!=0){
 	  papszLCO = CSLAddString(papszLCO, tmpMap->value );
+    }
     }
 
@@ -368,4 +386,8 @@
    
     tmpMap=NULL;
+    tmpMap=getMapFromMaps(inputs,"InputDS","cache_file");
+    if(tmpMap!=NULL){
+	    pszDataSource=strdup(tmpMap->value);
+    }else{
     tmpMap=getMapFromMaps(inputs,"InputDSN","value");
     if(tmpMap!=NULL && strncasecmp(tmpMap->value,"NULL",4)!=0){
@@ -384,4 +406,5 @@
 	sprintf((char*)pszDataSource,"%s",tmpMap->value);	
       }
+    }
     }
 
@@ -844,10 +867,10 @@
 	  setMapInMaps(conf,"lenv","message","There was an error when running yoru SQL query.");
 	  if(pszDialect!=NULL)
-	    free(pszDialect);
+	    free((void*)pszDialect);
 	  return SERVICE_FAILED;
 	}
     }
     if(pszDialect!=NULL)
-      free(pszDialect);
+      free((void*)pszDialect);
 
 /* -------------------------------------------------------------------- */
@@ -908,5 +931,23 @@
 
 #ifdef ZOO_SERVICE
+    tmpMap=getMapFromMaps(inputs,"InputDS","cache_file");
+    if(tmpMap==NULL)
     setMapInMaps(outputs,"OutputedDataSourceName","value",(char*)pszwebDestData);
+    else{
+	 tmpMap=getMapFromMaps(inputs,"OutputDSN","value");
+	 if(tmpMap!=NULL){ 
+		 map* tmpPath=getMapFromMaps(conf,"main","tmpPath");
+	   pszDestDataSource=(char*)malloc(sizeof(char)*(strlen(tmpMap->value)+1));
+	   sprintf((char*)pszDestDataSource,"%s",tmpMap->value/*,ext*/);
+	   pszwebDestData=(char*)malloc(sizeof(char)*(strlen(tmpPath->value)+strlen(tmpMap->value)+4));
+	   sprintf((char*)pszwebDestData,"%s/%s",tmpPath->value,tmpMap->value/*,ext*/);
+	   setMapInMaps(outputs,"OutputedDataSourceName","generated_file",(char*)pszwebDestData);
+	   setMapInMaps(outputs,"OutputedDataSourceName","mimeType","application/json");
+	   setMapInMaps(outputs,"OutputedDataSourceName","value","none");
+	//setMapInMaps(outputs,"OutputedDataSourceName","storage",(char*)pszwebDestData);
+         }
+	    
+    }
+    
     //outputs->content=createMap("value",(char*)pszwebDestData);
 #endif