Index: branches/branch-1.8/zoo-project/zoo-kernel/Makefile.in
===================================================================
--- branches/branch-1.8/zoo-project/zoo-kernel/Makefile.in	(revision 971)
+++ branches/branch-1.8/zoo-project/zoo-kernel/Makefile.in	(revision 979)
@@ -51,5 +51,5 @@
 
 sqlapi.o: sqlapi.c sqlapi.h
-	g++ -fPIC ${METADB_ENABLED} ${GDAL_CFLAGS} ${XML2CFLAGS} ${CFLAGS} ${JSCFLAGS} ${JS_ENABLED} -c sqlapi.c
+	g++ -fPIC ${JSON_CFLAGS} ${METADB_ENABLED} ${GDAL_CFLAGS} ${XML2CFLAGS} ${CFLAGS} ${JSCFLAGS} ${JS_ENABLED} -c sqlapi.c
 
 caching.o: caching.c
@@ -120,14 +120,14 @@
 	g++ -g -O2 ${JSON_CFLAGS} ${GDAL_CFLAGS} ${XML2CFLAGS} ${CFLAGS} ${MONO_CFLAGS} ${SAGA_CFLAGS} ${OTBCFLAGS} ${RCFLAGS} ${PYTHONCFLAGS} ${JAVACFLAGS} ${JSCFLAGS} ${PERLCFLAGS} ${PHPCFLAGS} ${SAGA_ENABLED} ${OTB_ENABLED} ${HPC_ENABLED} ${PYTHON_ENABLED} ${R_ENABLED} ${JS_ENABLED} ${PHP_ENABLED} ${PERL_ENABLED} ${JAVA_ENABLED} ${MONO_ENABLED} ${METADB_ENABLED} -c zoo_service_loader.c  -fno-common -DPIC -o zoo_service_loader.o
 
-libzoo_service.${EXT}: version.h service_internal.o service.o sqlapi.o
-	g++ -shared  ${GDAL_CFLAGS} ${DEFAULT_OPTS} -fpic -o libzoo_service.${EXT} ${CFLAGS}  service_internal.o service.o sqlapi.o ${FCGI_LDFLAGS} ${GDAL_LIBS} ${ZOO_LDFLAGS} ${MACOS_LD_FLAGS}
+libzoo_service.${EXT}: version.h service_internal.o service.o sqlapi.o ${CALLBACK_FILE}
+	g++ -shared  ${GDAL_CFLAGS} ${DEFAULT_OPTS} -fpic -o libzoo_service.${EXT} ${CFLAGS}  service_internal.o service.o sqlapi.o ${CALLBACK_FILE} ${FCGI_LDFLAGS} ${GDAL_LIBS} ${ZOO_LDFLAGS} ${MACOS_LD_FLAGS}
 
-zoo_loader.cgi: version.h libzoo_service.${EXT} zoo_loader.c zoo_service_loader.o  ulinet.o service.h lex.sr.o service_conf.tab.o service_conf.y ulinet.o main_conf_read.tab.o lex.cr.o request_parser.o response_print.o server_internal.o caching.o ${MS_FILE} ${PYTHON_FILE} ${PHP_FILE} ${JAVA_FILE} ${JS_FILE} ${PERL_FILE} ${RUBY_FILE} ${YAML_FILE} ${OTB_FILE} ${R_FILE} ${SAGA_FILE} ${HPC_FILES} ${METADB_FILE} ${JSON_FILE} ${CALLBACK_FILE}
+zoo_loader.cgi: version.h libzoo_service.${EXT} zoo_loader.c zoo_service_loader.o  ulinet.o service.h lex.sr.o service_conf.tab.o service_conf.y ulinet.o main_conf_read.tab.o lex.cr.o request_parser.o response_print.o server_internal.o caching.o ${MS_FILE} ${PYTHON_FILE} ${PHP_FILE} ${JAVA_FILE} ${JS_FILE} ${PERL_FILE} ${RUBY_FILE} ${YAML_FILE} ${OTB_FILE} ${R_FILE} ${SAGA_FILE} ${HPC_FILES} ${METADB_FILE} ${JSON_FILE} 
 	g++ -g -O2 ${JSON_CFLAGS} ${JSCFLAGS} ${PHPCFLAGS}  ${PERLCFLAGS} ${RUBYCFLAGS}  ${JAVACFLAGS} ${XML2CFLAGS} ${PYTHONCFLAGS} ${CFLAGS} -c zoo_loader.c  -fno-common -DPIC -o zoo_loader.o
-	g++  ${JSON_CFLAGS} ${JSCFLAGS} ${SAGA_CFLAGS} ${OTBCFLAGS} ${GDAL_CFLAGS} ${XML2CFLAGS} ${PHPCFLAGS} ${PERLCFLAGS} ${JAVACFLAGS} ${PYTHONCFLAGS} ${CFLAGS} zoo_loader.o zoo_service_loader.o ${MS_FILE} ${PYTHON_FILE}  ${PERL_FILE} ${PHP_FILE}  ${JS_FILE} ${JAVA_FILE} ${YAML_FILE} ${OTB_FILE} ${SAGA_FILE} ${MONO_FILE} ${HPC_FILES} ${METADB_FILE} ${JSON_FILE} ${R_FILE} ${CALLBACK_FILE} response_print.o server_internal.o caching.o request_parser.o ulinet.o lex.cr.o lex.sr.o service_conf.tab.o main_conf_read.tab.o -o zoo_loader.cgi -L. ${LDFLAGS}
+	g++  ${JSON_CFLAGS} ${JSCFLAGS} ${SAGA_CFLAGS} ${OTBCFLAGS} ${GDAL_CFLAGS} ${XML2CFLAGS} ${PHPCFLAGS} ${PERLCFLAGS} ${JAVACFLAGS} ${PYTHONCFLAGS} ${CFLAGS} zoo_loader.o zoo_service_loader.o ${MS_FILE} ${PYTHON_FILE}  ${PERL_FILE} ${PHP_FILE}  ${JS_FILE} ${JAVA_FILE} ${YAML_FILE} ${OTB_FILE} ${SAGA_FILE} ${MONO_FILE} ${HPC_FILES} ${METADB_FILE} ${JSON_FILE} ${R_FILE}  response_print.o server_internal.o caching.o request_parser.o ulinet.o lex.cr.o lex.sr.o service_conf.tab.o main_conf_read.tab.o -o zoo_loader.cgi -L. ${LDFLAGS}
 
-zcfg2yaml: zcfg2yaml.c service.h lex.sr.o service_conf.tab.o service_conf.y main_conf_read.tab.o lex.cr.o response_print.o server_internal.o service_internal.o ${MS_FILE} ${YAML_FILE} ${CALLBACK_FILE}
+zcfg2yaml: zcfg2yaml.c service.h lex.sr.o service_conf.tab.o service_conf.y main_conf_read.tab.o lex.cr.o response_print.o server_internal.o service_internal.o ${MS_FILE} ${YAML_FILE} 
 	g++ -g -O2 ${JSCFLAGS} ${RUBYCFLAGS} ${XML2CFLAGS} ${CFLAGS} -c zcfg2yaml.c  -fno-common -DPIC -o zcfg2yaml.o
-	g++  ${XML2CFLAGS} ${CFLAGS} zcfg2yaml.o caching.o ulinet.o ${CALLBACK_FILE} server_internal.o service_internal.o ${MS_FILE} response_print.o lex.cr.o lex.sr.o service_conf.tab.o main_conf_read.tab.o  ${YAML_FILE} -o zcfg2yaml -L. ${LDFLAGS}
+	g++  ${XML2CFLAGS} ${CFLAGS} zcfg2yaml.o caching.o ulinet.o server_internal.o service_internal.o ${MS_FILE} response_print.o lex.cr.o lex.sr.o service_conf.tab.o main_conf_read.tab.o  ${YAML_FILE} -o zcfg2yaml -L. ${LDFLAGS}
 
 install: zoo_loader.cgi
Index: branches/branch-1.8/zoo-project/zoo-kernel/makefile.vc
===================================================================
--- branches/branch-1.8/zoo-project/zoo-kernel/makefile.vc	(revision 971)
+++ branches/branch-1.8/zoo-project/zoo-kernel/makefile.vc	(revision 979)
@@ -107,6 +107,6 @@
 	link zoo_loader.obj request_parser.obj response_print.obj server_internal.obj caching.obj service_json.obj service_callback.obj $(PY_FILE) $(JAVA_FILE) $(MS_FILE) $(JS_FILE) $(MONO_FILE) $(RUBY_FILE) $(PHP_FILE) ulinet.obj main_conf_read.tab.obj lex.cr.obj service_conf.tab.obj lex.sr.obj  zoo_service_loader.obj ./libzoo_service.lib /out:$(PROGRAMNAME) $(LDFLAGS) $(LDFLAGSCGI) $(JSONC_LIB) $(PTHREADS_LIB) $(XSLT_LIB)
 
-zcfg2yaml: version.h zcfg2yaml.obj zoo_service_loader.obj service_internal.obj caching.obj $(PY_FILE) $(JAVA_FILE) $(MS_FILE) $(JS_FILE) $(MONO_FILE) $(RUBY_FILE) ulinet.obj lex.cr.obj lex.sr.obj service_conf.tab.obj main_conf_read.tab.obj
-	link zcfg2yaml.obj server_internal.obj caching.obj $(PY_FILE) $(JAVA_FILE) $(MS_FILE) $(JS_FILE) $(MONO_FILE) $(RUBY_FILE) $(PHP_FILE) ulinet.obj response_print.obj main_conf_read.tab.obj lex.cr.obj service_conf.tab.obj lex.sr.obj ./libzoo_service.lib /out:zcfg2yaml.exe $(LDFLAGS) $(LDFLAGSCGI)
+zcfg2yaml: version.h zcfg2yaml.obj zoo_service_loader.obj service_internal.obj caching.obj service_json.obj $(PY_FILE) $(JAVA_FILE) $(MS_FILE) $(JS_FILE) $(MONO_FILE) $(RUBY_FILE) ulinet.obj lex.cr.obj lex.sr.obj service_conf.tab.obj main_conf_read.tab.obj
+	link zcfg2yaml.obj server_internal.obj caching.obj service_json.obj $(PY_FILE) $(JAVA_FILE) $(MS_FILE) $(JS_FILE) $(MONO_FILE) $(RUBY_FILE) $(PHP_FILE) ulinet.obj response_print.obj main_conf_read.tab.obj lex.cr.obj service_conf.tab.obj lex.sr.obj ./libzoo_service.lib /out:zcfg2yaml.exe $(LDFLAGS) $(LDFLAGSCGI) $(JSONC_LIB)
 
 clean:
Index: branches/branch-1.8/zoo-project/zoo-kernel/service.h
===================================================================
--- branches/branch-1.8/zoo-project/zoo-kernel/service.h	(revision 971)
+++ branches/branch-1.8/zoo-project/zoo-kernel/service.h	(revision 979)
@@ -88,4 +88,5 @@
 
 #else
+#include <sys/stat.h>
 /**
  * The crossplatform strdup alias
@@ -95,5 +96,7 @@
  * The crossplatform mkdir alias
  */
-#define zMkdir mkdir
+static int zMkdir(const char* pccPath){
+  return mkdir(pccPath,0777);
+}
 /**
  * The crossplatform open alias
Index: branches/branch-1.8/zoo-project/zoo-kernel/service_callback.c
===================================================================
--- branches/branch-1.8/zoo-project/zoo-kernel/service_callback.c	(revision 971)
+++ branches/branch-1.8/zoo-project/zoo-kernel/service_callback.c	(revision 979)
@@ -27,5 +27,7 @@
  */
 
+#ifdef USE_CALLBACK
 #include "service_internal_ms.h"
+#endif
 #include <pthread.h>
 #include <libxml/tree.h>
@@ -284,5 +286,6 @@
     return true;
   }
-  
+
+#ifdef USE_CALLBACK
   /**
    * Practically invoke the callback, meaning sending the HTTP POST request.
@@ -1035,5 +1038,6 @@
     return true;
   }
-
+#endif
+  
   /**
    * Wait for the threads to end then, clean used memory.
Index: branches/branch-1.8/zoo-project/zoo-kernel/service_callback.h
===================================================================
--- branches/branch-1.8/zoo-project/zoo-kernel/service_callback.h	(revision 971)
+++ branches/branch-1.8/zoo-project/zoo-kernel/service_callback.h	(revision 979)
@@ -39,5 +39,7 @@
 
   bool invokeBasicCallback(maps*,int);
+#ifdef USE_CALLBACK
   bool invokeCallback(maps*,maps*,maps*,int,int);
+#endif
   void cleanupCallbackThreads();
   
Index: branches/branch-1.8/zoo-project/zoo-kernel/service_internal.c
===================================================================
--- branches/branch-1.8/zoo-project/zoo-kernel/service_internal.c	(revision 971)
+++ branches/branch-1.8/zoo-project/zoo-kernel/service_internal.c	(revision 979)
@@ -30,4 +30,5 @@
 #endif
 #include "service_internal.h"
+#include "service_callback.h"
 
 #ifdef WIN32
@@ -471,5 +472,7 @@
       fflush(fstatus);
       fclose(fstatus);
+#ifdef USE_JSON
       invokeBasicCallback(conf,SERVICE_STARTED);
+#endif
     }
     if(stat!=NULL){
Index: branches/branch-1.8/zoo-project/zoo-kernel/service_json.c
===================================================================
--- branches/branch-1.8/zoo-project/zoo-kernel/service_json.c	(revision 971)
+++ branches/branch-1.8/zoo-project/zoo-kernel/service_json.c	(revision 979)
@@ -1318,5 +1318,5 @@
 	    tmpPath->value,
 	    cIdentifier->value);
-    if(mkdir(tmp1,0777) != 0 && errno != EEXIST){
+    if(zMkdir(tmp1) != 0 && errno != EEXIST){
       fprintf(stderr,"Issue creating directory %s\n",tmp1);
       return NULL;
Index: branches/branch-1.8/zoo-project/zoo-kernel/service_json.h
===================================================================
--- branches/branch-1.8/zoo-project/zoo-kernel/service_json.h	(revision 971)
+++ branches/branch-1.8/zoo-project/zoo-kernel/service_json.h	(revision 979)
@@ -50,5 +50,5 @@
   void printGetCapabilitiesForProcessJ(registry*, maps*,void*,void*,service*);
   void printExceptionReportResponseJ(maps*,map*);
-  void parseJRequest(maps*,service* s,json_object*,map*,maps**,maps**);
+  void parseJRequest(maps*,service*,json_object*,map*,maps**,maps**);
   json_object*  printJResult(maps*,service*,maps*,int);
   json_object* printJobStatus(maps*,char*);
Index: branches/branch-1.8/zoo-project/zoo-kernel/sqlapi.c
===================================================================
--- branches/branch-1.8/zoo-project/zoo-kernel/sqlapi.c	(revision 971)
+++ branches/branch-1.8/zoo-project/zoo-kernel/sqlapi.c	(revision 979)
@@ -389,5 +389,7 @@
   cleanUpResultSet(conf,zoo_ds_nb-1);
   free(sqlQuery);
+#ifdef USE_JSON  
   invokeBasicCallback(conf,SERVICE_STARTED);
+#endif
   return 0;
 }
Index: branches/branch-1.8/zoo-project/zoo-kernel/zoo_service_loader.c
===================================================================
--- branches/branch-1.8/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 971)
+++ branches/branch-1.8/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 979)
@@ -69,5 +69,5 @@
 #include "service.h"
 
-#ifdef USE_JSON
+#if defined(WIN32) || defined(USE_JSON)
 #include "caching.h"
 #endif
@@ -696,4 +696,5 @@
 }
 
+#ifdef USE_JSON
 /**
  * Run every HTTP request to download inputs passed as reference
@@ -738,4 +739,5 @@
   return 0;
 }
+#endif
 
 /**
@@ -985,5 +987,5 @@
     addToMap (request_inputs, "status", "true");
     setMapInMaps (conf, "lenv", "osid", test1->value);
-    status = getMap (request_inputs, "status");
+    //status = getMap (request_inputs, "status");
   }
   test1 = getMap (request_inputs, "usid");