Index: branches/branch-1.8/zoo-project/HISTORY.txt
===================================================================
--- branches/branch-1.8/zoo-project/HISTORY.txt	(revision 979)
+++ branches/branch-1.8/zoo-project/HISTORY.txt	(revision 981)
@@ -1,3 +1,3 @@
-Version 1.8.0-dev
+Version 1.8.0
   * Support raw response in OGC API - Processes
   * Add a ZOO-API section to the howtos documentation
Index: branches/branch-1.8/zoo-project/zoo-api/java/makefile.vc
===================================================================
--- branches/branch-1.8/zoo-project/zoo-api/java/makefile.vc	(revision 981)
+++ branches/branch-1.8/zoo-project/zoo-api/java/makefile.vc	(revision 981)
@@ -0,0 +1,37 @@
+# WIN32 Makefile tested using VC-9.0
+# Don't forget to set your PATH using the following command :
+# c:\Progam Files (x86)\Microsoft Visual Studio 9.0\VC\bin\vcvars32.bat
+# set PATH=%PATH%;$(TOOLS)
+# using value for TOOLS relative to your local installation
+#
+
+!INCLUDE ..\..\zoo-kernel\nmake.opt
+
+!IFDEF JAVA_FILE
+JAVA_FILE=..\..\zoo-kernel/$(JAVA_FILE)
+!ENDIF
+!IFDEF MS_FILE
+MS_FILE=..\..\zoo-kernel/$(MS_FILE)
+!ENDIF
+!IFDEF JS_FILE
+JS_FILE=..\..\zoo-kernel/$(JS_FILE)
+!ENDIF
+
+all:  libZOO.dll
+
+org/zoo_project/ZOO.class: org/zoo_project/ZOO.java
+	javac org/zoo_project/ZOO.java
+
+ZOO.h: org/zoo_project/ZOO.java org/zoo_project/ZOO.class
+	javah org.zoo_project.ZOO
+
+zoo-api.o: zoo-api.c ZOO.h
+	$(CPP) /c $(CFLAGS) zoo-api.c -I../../zoo-kernel/ -I../../../thirds/cgic206/ 
+
+libZOO.dll: zoo-api.o
+	link /dll /out:libZOO.dll zoo-api.obj ..\..\zoo-kernel\libzoo_service.lib ..\..\zoo-kernel\server_internal.obj ..\..\zoo-kernel\caching.obj ..\..\zoo-kernel\ulinet.obj ..\..\zoo-kernel\response_print.obj ..\..\zoo-kernel\service_json.obj ..\..\zoo-kernel\main_conf_read.tab.obj ..\..\zoo-kernel\service_conf.tab.obj ..\..\zoo-kernel\lex.cr.obj ..\..\zoo-kernel\lex.sr.obj $(JAVA_FILE) $(MS_FILE) $(JS_FILE) $(JSONC_LIB) $(LDFLAGS) /FORCE:MULTIPLE
+
+clean:
+	erase -f *dll *lib *o *.h *class
+
+
Index: branches/branch-1.8/zoo-project/zoo-kernel/Makefile.in
===================================================================
--- branches/branch-1.8/zoo-project/zoo-kernel/Makefile.in	(revision 979)
+++ branches/branch-1.8/zoo-project/zoo-kernel/Makefile.in	(revision 981)
@@ -4,5 +4,5 @@
 
 version.h: Makefile
-	echo "#define ZOO_VERSION \"1.8.0-rc1 `svnversion`\"" > version.h
+	echo "#define ZOO_VERSION \"1.8.0 `svnversion`\"" > version.h
 	echo "@ETC_DEF@" >> version.h
 	echo "#define LOCALEDIR \"@localedir@\"" >>  version.h
Index: branches/branch-1.8/zoo-project/zoo-kernel/configure.ac
===================================================================
--- branches/branch-1.8/zoo-project/zoo-kernel/configure.ac	(revision 979)
+++ branches/branch-1.8/zoo-project/zoo-kernel/configure.ac	(revision 981)
@@ -1,3 +1,3 @@
-AC_INIT([ZOO Kernel], [1.8.0-rc1], [bugs@zoo-project.org])
+AC_INIT([ZOO Kernel], [1.8.0], [bugs@zoo-project.org])
 
 AC_CONFIG_MACRO_DIR([macros])
Index: branches/branch-1.8/zoo-project/zoo-services/cgal/voronoi.c
===================================================================
--- branches/branch-1.8/zoo-project/zoo-services/cgal/voronoi.c	(revision 979)
+++ branches/branch-1.8/zoo-project/zoo-services/cgal/voronoi.c	(revision 981)
@@ -198,13 +198,4 @@
     int nr = 0;
     int nf = 0;
-    Face_iterator fit =T.faces_begin();
-    FILE* f=fopen("/tmp/toto.log","w+");
-    for ( ; fit !=T.faces_end(); ++fit) {
-      fprintf(stderr," *** %s %d %d %d\n",__FILE__,__LINE__,nf,fit.info());
-      fflush(stderr);
-      
-      nf++;
-    }
-    fclose(f);
     Edge_iterator eit =T.edges_begin();
     for ( ; eit !=T.edges_end(); ++eit) {
Index: branches/branch-1.8/zoo-project/zoo-services/gdal/profile/service.c
===================================================================
--- branches/branch-1.8/zoo-project/zoo-services/gdal/profile/service.c	(revision 979)
+++ branches/branch-1.8/zoo-project/zoo-services/gdal/profile/service.c	(revision 981)
@@ -35,7 +35,4 @@
 #include "cpl_conv.h"
 #include "ogr_api.h"
-#if GDAL_VERSION_MAJOR >= 2
-#include <gdal_priv.h>
-#endif
 
 #ifdef ZOO_SERVICE
Index: branches/branch-1.8/zoo-project/zoo-services/utils/registry/makefile.vc
===================================================================
--- branches/branch-1.8/zoo-project/zoo-services/utils/registry/makefile.vc	(revision 979)
+++ branches/branch-1.8/zoo-project/zoo-services/utils/registry/makefile.vc	(revision 981)
@@ -14,10 +14,10 @@
 !ENDIF
 !IFDEF MS_DIR
-FILES=$(FILES) $(ZOOK_DIR)$(MS_FILE)
+FILES=$(FILES) $(ZOOK_DIR)$(MS_FILE) $(ZOOK_DIR)/caching.obj $(ZOOK_DIR)/ulinet.obj
 !ENDIF
 
 cgi-env/wps_registry.zo: service.c
 	$(CPP) /D_CRT_NONSTDC_NO_DEPRECATE -DWIN32 -DZOO_SERVICE $(CFLAGS) /c service.c
-	link /dll /out:cgi-env/wps_registry.zo $(FILES) ./service.obj $(LDFLAGS) /FORCE:MULTIPLE
+	link /dll /out:cgi-env/wps_registry.zo $(FILES) ./service.obj $(ZOOK_DIR)/service_json.obj $(JSONC_LIB) $(LDFLAGS) /FORCE:MULTIPLE
 
 clean: