Index: trunk/docker/main.cfg
===================================================================
--- trunk/docker/main.cfg	(revision 984)
+++ trunk/docker/main.cfg	(revision 985)
@@ -6,5 +6,5 @@
 lang = fr-FR,en-CA,en-US
 tmpPath=/tmp/
-tmpUrl = ../temp/
+tmpUrl = http://localhost/temp/
 dataPath = /usr/com/zoo-project
 cacheDir = /tmp/
@@ -15,6 +15,6 @@
 
 [identification]
-title = The ZOO-Project OGC WPS Development Server
-abstract = Development version of ZOO-Project OGC WPS. See http://www.zoo-project.org
+title = The ZOO-Project OGC WPS Developement Server
+abstract = Developement version of ZOO-Project OGC WPS. See http://www.zoo-project.org
 fees = None
 accessConstraints = none
Index: trunk/docker/oas.cfg
===================================================================
--- trunk/docker/oas.cfg	(revision 984)
+++ trunk/docker/oas.cfg	(revision 985)
@@ -2,6 +2,6 @@
 use_content=false
 rootUrl=http://localhost/ogc-api
-links=/,/api,/conformance,/processes
-paths=/root,/api,/conformance,/processes,/processes/{id},/processes/{id}/jobs,/processes/{id}/jobs/{jobID},/processes/{id}/jobs/{jobID}/results
+links=/,/api,/conformance,/processes,/jobs
+paths=/root,/api,/conformance,/processes,/processes/{id},/jobs,/jobs/{jobID},/jobs/{jobID}/results
 parameters=id,jobID,resultID
 version=3.0.2
@@ -24,5 +24,5 @@
 tags=Home
 tags_description=
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/LandingPage.yaml
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/LandingPage.yaml
 
 [/index.html]
@@ -61,5 +61,5 @@
 tags=Conformance
 tags_description=
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/ConformanceDeclaration.yaml
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ConformanceDeclaration.yaml
 
 [/conformance.html]
@@ -78,5 +78,5 @@
 tags=GetCapabilities
 tags_description=
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/ProcessList.yaml
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ProcessList.yaml
 
 [/processes.html]
@@ -90,5 +90,5 @@
 tags=ProcessDescription
 tags_description=
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/ProcessDescription.yaml
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ProcessDescription.yaml
 ecode=404
 parameters=/components/parameters/id
@@ -107,5 +107,5 @@
 tags=JobList
 tags_description=
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/JobList.yaml
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/JobList.yaml
 parameters=/components/parameters/id
 ecode=404,500
@@ -115,8 +115,34 @@
 tags_1=Execute Endpoint
 tags_description_1=
-schema_1=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/ExecuteSync.yaml
+schema_1=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ExecuteSync.yaml
 parameters_1=/components/parameters/id
 ecode_1=400,404,500
-eschema_1=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/ExecuteAsync.yaml
+eschema_1=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ExecuteAsync.yaml
+ep=,/components/parameters/oas-header1
+
+[/jobs]
+rel=canonical
+type=application/json
+title=Execute Endpoint
+
+[jobs]
+length=2
+method=get
+title=retrieve a list of jobs run
+abstract=A list of jobs run.
+tags=JobList
+tags_description=
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/JobList.yaml
+parameters=
+ecode=404,500
+method_1=post
+title_1=execute a job
+abstract_1=An execute endpoint.
+tags_1=ExecuteEndpoint
+tags_description_1=
+schema_1=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ExecuteSync.yaml
+parameters_1=
+ecode_1=400,404,500
+eschema_1=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ExecuteAsync.yaml
 ep=,/components/parameters/oas-header1
 
@@ -124,5 +150,9 @@
 abstract=Mandatory execute request in JSON format
 type=application/json
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/schemas/execute.yaml
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/schemas/execute.yaml
+
+[/jobs.html]
+rel=alternate
+type=text/hml
 
 [/processes/{id}/jobs/{jobID}]
@@ -138,5 +168,5 @@
 tags=GetStatus
 tags_description=
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/Status.yaml
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/Status.yaml
 parameters=/components/parameters/id,/components/parameters/jobID
 method_1=delete
@@ -145,6 +175,29 @@
 tags_1=Dismiss
 tags_description_1=Cencel a job execution
-schema_1=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/Status.yaml
+schema_1=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/Status.yaml
 parameters_1=/components/parameters/id,/components/parameters/jobID
+ecode_1=404,500
+
+[/jobs/{jobID}]
+rel=canonical
+type=application/json
+title=Status
+
+[jobs/{jobID}]
+length=2
+method=get
+title=The status of a job.
+abstract=The status of a job.
+tags=GetStatus
+tags_description=
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/Status.yaml
+parameters=/components/parameters/jobID
+method_1=delete
+title_1=Cancel a job
+abstract_1=Cancel the job execution.
+tags_1=Dismiss
+tags_description_1=Cancel a job execution
+schema_1=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/Status.yaml
+parameters_1=/components/parameters/jobID
 ecode_1=404,500
 
@@ -161,15 +214,15 @@
 tags=GetResult
 tags_description=
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/Results.yaml
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/Results.yaml
 parameters=/components/parameters/id,/components/parameters/jobID
 ecode=404,500
 ep=,/components/parameters/oas-header2
 
-[/processes/{id}/jobs/{jobID}/result/{resultID}]
+[/jobs/{jobID}/results]
 rel=canonical
 type=application/json
 title=Get Result
 
-[processes/{id}/jobs/{jobID}/result/{resultID}]
+[jobs/{jobID}/results]
 method=get
 title=The result of a job execution.
@@ -177,5 +230,21 @@
 tags=GetResult
 tags_description=
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/schemas/valueType.yaml
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/Results.yaml
+parameters=/components/parameters/jobID
+ecode=404,500
+ep=,/components/parameters/oas-header2
+
+[/processes/{id}/jobs/{jobID}/result/{resultID}]
+rel=canonical
+type=application/json
+title=Get Result
+
+[processes/{id}/jobs/{jobID}/result/{resultID}]
+method=get
+title=The result of a job execution.
+abstract=The result of a job execution.
+tags=GetResult
+tags_description=
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/schemas/valueType.yaml
 parameters=/components/parameters/id,/components/parameters/jobID,/components/parameters/resultID
 ep=,/components/parameters/oas-header2
@@ -213,5 +282,5 @@
 
 [conformsTo]
-rootUrl=http://www.opengis.net/spec/ogcapi-processes/1.0/conf/
+rootUrl=http://www.opengis.net/spec/ogcapi-processes/1.0/req/
 rootUrl0=http://www.opengis.net/spec/WPS/2.0/req/service/binding/rest-json/
 link=core
@@ -221,32 +290,34 @@
 link_4=dismiss
 link_5=callback
-length=6
+link_6=ogc-process-description
+link_7=html
+length=8
 
 [exception]
 abstract=Exception
 type=application/json
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/NotFound.yaml
-default_schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/ServerError.yaml
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/schemas/responses/NotFound.yaml
+default_schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ServerError.yaml
 
 [responses]
 length=5
 code=404
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/NotFound.yaml
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/NotFound.yaml
 type=application/json
 title=NotFound
 code_1=500
-schema_1=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/ServerError.yaml
+schema_1=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ServerError.yaml
 type_1=application/json
 title_1=ServerError
 code_2=400
-schema_2=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/InvalidParameter.yaml
+schema_2=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/InvalidParameter.yaml
 type_2=appliction/json
 title_2=InvalidParameter
 code_3=405
-schema_3=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/NotAllowed.yaml
+schema_3=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/NotAllowed.yaml
 type_3=appliction/json
 title_3=NotAllowed
 code_4=406
-schema_4=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/responses/NotSupported.yaml
+schema_4=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/NotSupported.yaml
 type_4=appliction/json
 title_4=NotSupported
@@ -256,15 +327,15 @@
 state=jobSuccess
 uri=successUri
-schema=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/schemas/result.yaml
+schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/schemas/result.yaml
 type=application/json
 title=Results received successfully
 state_1=jobInProgress
 uri_1=inProgressUri
-schema_1=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/schemas/statusInfo.yaml
+schema_1=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/schemas/statusInfo.yaml
 type_1=application/json
 title_1=Results received successfully
 state_2=jobFailed
 uri_2=failedUrii
-schema_2=https://raw.githubusercontent.com/gfenoy/wps-rest-binding/change-request/95/core/openapi/schemas/exception.yaml
+schema_2=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/schemas/exception.yaml
 type_2=application/json
 title_2=Exception received successfully