Index: trunk/docker/oas.cfg
===================================================================
--- trunk/docker/oas.cfg	(revision 985)
+++ trunk/docker/oas.cfg	(revision 986)
@@ -3,10 +3,10 @@
 rootUrl=http://localhost/ogc-api
 links=/,/api,/conformance,/processes,/jobs
-paths=/root,/api,/conformance,/processes,/processes/{id},/jobs,/jobs/{jobID},/jobs/{jobID}/results
-parameters=id,jobID,resultID
+paths=/root,/api,/conformance,/processes,/processes/{processID},/jobs,/jobs/{jobID},/jobs/{jobID}/results
+parameters=processID,jobID,resultID
 version=3.0.2
 license_name=OGC license
-license_url=https://raw.githubusercontent.com/opengeospatial/wps-rest-binding/master/LICENSE
-full_html_support=false
+license_url=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/LICENSE
+full_html_support=true
 partial_html_support=true
 wsUrl=ws://localhost:8888/
@@ -84,5 +84,6 @@
 type=text/hml
 
-[processes/{id}]
+[processes/{processID}]
+length=2
 method=get
 title=retrieve a process description
@@ -92,22 +93,5 @@
 schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ProcessDescription.yaml
 ecode=404
-parameters=/components/parameters/id
-
-
-[/processes/{id}/jobs]
-rel=canonical
-type=application/json
-title=Process Description
-
-[processes/{id}/jobs]
-length=2
-method=get
-title=retrieve a list of jobs run
-abstract=A list of jobs run.
-tags=JobList
-tags_description=
-schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/JobList.yaml
-parameters=/components/parameters/id
-ecode=404,500
+parameters=/components/parameters/processID
 method_1=post
 title_1=execute a job
@@ -116,16 +100,15 @@
 tags_description_1=
 schema_1=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ExecuteSync.yaml
-parameters_1=/components/parameters/id
+parameters_1=/components/parameters/processID
 ecode_1=400,404,500
 eschema_1=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/ExecuteAsync.yaml
-ep=,/components/parameters/oas-header1
 
 [/jobs]
 rel=canonical
 type=application/json
-title=Execute Endpoint
+title=Job Management
 
 [jobs]
-length=2
+length=1
 method=get
 title=retrieve a list of jobs run
@@ -156,27 +139,4 @@
 type=text/hml
 
-[/processes/{id}/jobs/{jobID}]
-rel=canonical
-type=application/json
-title=Status
-
-[processes/{id}/jobs/{jobID}]
-length=2
-method=get
-title=The status of a job.
-abstract=The status of a job.
-tags=GetStatus
-tags_description=
-schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/Status.yaml
-parameters=/components/parameters/id,/components/parameters/jobID
-method_1=delete
-title_1=Cancel a job
-abstract_1=Cancel the job execution.
-tags_1=Dismiss
-tags_description_1=Cencel a job execution
-schema_1=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/Status.yaml
-parameters_1=/components/parameters/id,/components/parameters/jobID
-ecode_1=404,500
-
 [/jobs/{jobID}]
 rel=canonical
@@ -202,21 +162,4 @@
 ecode_1=404,500
 
-
-[/processes/{id}/jobs/{jobID}/results]
-rel=canonical
-type=application/json
-title=Get Result
-
-[processes/{id}/jobs/{jobID}/results]
-method=get
-title=The result of a job execution.
-abstract=The result of a job execution.
-tags=GetResult
-tags_description=
-schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/responses/Results.yaml
-parameters=/components/parameters/id,/components/parameters/jobID
-ecode=404,500
-ep=,/components/parameters/oas-header2
-
 [/jobs/{jobID}/results]
 rel=canonical
@@ -235,21 +178,5 @@
 ep=,/components/parameters/oas-header2
 
-[/processes/{id}/jobs/{jobID}/result/{resultID}]
-rel=canonical
-type=application/json
-title=Get Result
-
-[processes/{id}/jobs/{jobID}/result/{resultID}]
-method=get
-title=The result of a job execution.
-abstract=The result of a job execution.
-tags=GetResult
-tags_description=
-schema=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/schemas/valueType.yaml
-parameters=/components/parameters/id,/components/parameters/jobID,/components/parameters/resultID
-ep=,/components/parameters/oas-header2
-
-
-[{id}]
+[{processID}]
 type=string
 title=The id of a process
@@ -334,7 +261,7 @@
 schema_1=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/schemas/statusInfo.yaml
 type_1=application/json
-title_1=Results received successfully
+title_1=Status received successfully
 state_2=jobFailed
-uri_2=failedUrii
+uri_2=failedUri
 schema_2=https://raw.githubusercontent.com/opengeospatial/ogcapi-processes/master/core/openapi/schemas/exception.yaml
 type_2=application/json